
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stone_3d_assetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stone_3d_assets = await db.stone_3d_assets.create(
            {
                id: data.id || undefined,
        
        asset_type: data.asset_type
        ||
        null
            ,
            
        viewer_hint_ar: data.viewer_hint_ar
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stone_3d_assets.setStone( data.stone || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.stone_3d_assets.getTableName(),
                belongsToColumn: 'asset_file',
                belongsToId: stone_3d_assets.id,
            },
            data.asset_file,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.stone_3d_assets.getTableName(),
                belongsToColumn: 'preview_images',
                belongsToId: stone_3d_assets.id,
            },
            data.preview_images,
            options,
        );
        

        return stone_3d_assets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stone_3d_assetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                asset_type: item.asset_type
            ||
            null
            ,
            
                viewer_hint_ar: item.viewer_hint_ar
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stone_3d_assets = await db.stone_3d_assets.bulkCreate(stone_3d_assetsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < stone_3d_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.stone_3d_assets.getTableName(),
                    belongsToColumn: 'asset_file',
                    belongsToId: stone_3d_assets[i].id,
                },
                data[i].asset_file,
                options,
            );
        }
        
        for (let i = 0; i < stone_3d_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.stone_3d_assets.getTableName(),
                    belongsToColumn: 'preview_images',
                    belongsToId: stone_3d_assets[i].id,
                },
                data[i].preview_images,
                options,
            );
        }
        

        return stone_3d_assets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const stone_3d_assets = await db.stone_3d_assets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.asset_type !== undefined) updatePayload.asset_type = data.asset_type;
        
        
        if (data.viewer_hint_ar !== undefined) updatePayload.viewer_hint_ar = data.viewer_hint_ar;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await stone_3d_assets.update(updatePayload, {transaction});

        
        
        if (data.stone !== undefined) {
            await stone_3d_assets.setStone(
              
              data.stone,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.stone_3d_assets.getTableName(),
                belongsToColumn: 'asset_file',
                belongsToId: stone_3d_assets.id,
            },
            data.asset_file,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.stone_3d_assets.getTableName(),
                belongsToColumn: 'preview_images',
                belongsToId: stone_3d_assets.id,
            },
            data.preview_images,
            options,
        );
        

        return stone_3d_assets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stone_3d_assets = await db.stone_3d_assets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stone_3d_assets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stone_3d_assets) {
                await record.destroy({transaction});
            }
        });


        return stone_3d_assets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stone_3d_assets = await db.stone_3d_assets.findByPk(id, options);

        await stone_3d_assets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stone_3d_assets.destroy({
            transaction
        });

        return stone_3d_assets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stone_3d_assets = await db.stone_3d_assets.findOne(
            { where },
            { transaction },
        );

        if (!stone_3d_assets) {
            return stone_3d_assets;
        }

        const output = stone_3d_assets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.stone = await stone_3d_assets.getStone({
            transaction
        });
        
        
        output.asset_file = await stone_3d_assets.getAsset_file({
            transaction
        });
        
        
        output.preview_images = await stone_3d_assets.getPreview_images({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stones,
        as: 'stone',
        
        where: filter.stone ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stone.split('|').map(term => Utils.uuid(term)) } },
            {
              name_ar: {
                [Op.or]: filter.stone.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'asset_file',
      },

      {
        model: db.file,
        as: 'preview_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.viewer_hint_ar) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stone_3d_assets',
                        'viewer_hint_ar',
                        filter.viewer_hint_ar,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.asset_type) {
                where = {
                    ...where,
                asset_type: filter.asset_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stone_3d_assets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stone_3d_assets',
                        'viewer_hint_ar',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stone_3d_assets.findAll({
            attributes: [ 'id', 'viewer_hint_ar' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['viewer_hint_ar', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.viewer_hint_ar,
        }));
    }

    
};

